.486
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\masm32.inc
include  \masm32\include\Comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\m32lib\masm32.lib
includelib \masm32\lib\user32.lib
includelib  \masm32\lib\Comctl32.lib


WinMain       proto :DWORD,:DWORD,:DWORD,:DWORD
MakeRegion    proto :HDC, :DWORD, :DWORD

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.const
IDB_MAIN        equ 1
PictureW        equ 300; picture width in pixels
PictureH        equ 300; picture height in pixels
ButtonID        equ 1000
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data
ClassName      db "SkinClass",0
AppName        db "No RGN Window Region",0
DisplayName     db "custom windows shape",0
.data
Text            db "good bye...",0              

ButtonClassName db "button",0
ButtonText      db "Click Me!",0
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.data?
hInstance        HINSTANCE ?
CommandLine      LPSTR ?
hBitmap          dd ?
hwndButton      dd ?
.code

include rgn.inc

start:

    invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke InitCommonControls
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT	
	invoke ExitProcess,eax

;###############################################################################
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND

	invoke LoadIcon,hInstance,102
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,hInstance,102
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_CROSS ;IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc

	invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,PictureW/2
    push    eax

    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,PictureH/2
    pop     ebx

; -->   CREATE OUR WINDOW (WITH POPUP STYLE!)
        invoke  CreateWindowEx,WS_EX_LEFT,ADDR ClassName,ADDR AppName,
                WS_POPUP,ebx,eax,PictureW,PictureH,NULL,NULL,hInst,NULL
        mov     hwnd,eax
	


	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	.while TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.break .if (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	mov     eax,msg.wParam
	

	ret
WinMain endp

;##########################################################################
WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
   LOCAL ps:PAINTSTRUCT
   LOCAL hdc:HDC
   LOCAL hMemDC:HDC
   LOCAL rect:RECT
   LOCAL myDC:HDC
   LOCAL point:RECT
   LOCAL hInstan :DWORD

  	mov		eax,uMsg

   .if eax==WM_CREATE

   
	invoke LoadBitmap,hInstance,IDB_MAIN
	mov hBitmap,eax
	invoke GetWindowDC,hWnd
	mov hdc,eax
	invoke CreateCompatibleDC,hdc
	mov hMemDC,eax
    invoke SelectObject,hMemDC,hBitmap
    invoke GetWindowRect,hWnd,addr rect
	

		invoke GetClientRect,hWnd,ADDR rect
		mov eax,hMemDC
		mov myDC,eax
		push rect.bottom
		push rect.right
		push hMemDC 
		call MakeRegion

;Regions have to be set to the window you wish to apply them to via: SetWindowRgn
;you can do this whenever you wish to
;using a value of 0 (zero) resets the region e.g. invoke SetWindowRgn,hWnd,0,TRUE

		invoke SetWindowRgn,hWnd,eax,TRUE

;end skin code
	
			
	invoke ReleaseDC,hWnd,hdc
	invoke DeleteDC,hMemDC
	

	invoke SetTimer,hWnd,123,500,0
	
    invoke  SetWindowPos,hWnd,HWND_TOPMOST,ebx,eax,\
    PictureW,PictureH,SWP_SHOWWINDOW
; -->   CREATE A SIMPLE BUTTON
        invoke  CreateWindowEx,NULL, ADDR ButtonClassName,ADDR ButtonText,\
                WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,\
                150,185,100,25,hWnd,ButtonID,hInstance,NULL
        mov     hwndButton,eax
	
	.elseif eax == WM_COMMAND 
      mov eax,wParam 
      and eax,0FFFFh 
      
  .if  eax == ButtonID
        invoke  MessageBox,hWnd,addr Text,addr DisplayName,MB_OK
        invoke KillTimer,hWnd,123
        invoke DeleteObject,hBitmap
	    invoke PostQuitMessage,NULL
     .endif   	  
  
    .elseif (eax==WM_LBUTTONDOWN  || eax==WM_LBUTTONDBLCLK)
    
		invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0
		

    .elseif eax==WM_PAINT
    	invoke GetClientRect,hWnd,addr rect
	    invoke BeginPaint,hWnd,addr ps
	    mov hdc,eax
        invoke CreateCompatibleDC,hdc
 	    mov hMemDC,eax
	    invoke SelectObject,hMemDC,hBitmap
	    invoke BitBlt,hdc,0,0,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
	    invoke DeleteDC,hMemDC
	    invoke EndPaint,hWnd,addr ps	

    .elseif edi==WM_DESTROY || uMsg == WM_RBUTTONUP
    invoke KillTimer,hWnd,123
    invoke DeleteObject,hBitmap
	invoke PostQuitMessage,NULL
    
    .IF eax==WM_LBUTTONDOWN 
    
mov eax, lParam
and eax, 0FFFFh
mov edx, lParam
shr edx, 16

  invoke ExitProcess,eax

 .endif   

    call ReleaseCapture
	invoke SendMessage,hWnd,WM_NCLBUTTONDOWN, HTCAPTION,0
    .ELSE
	invoke DefWindowProc,hWnd,uMsg,wParam,lParam		

	ret
 
    .ENDIF

xor eax,eax
ret
WndProc endp
; ############################################################### 
end start